<!DOCTYPE html>
<html lang="en">

<head>
    <title>document</title>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
    <!-- Import style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <h1 class="text-center">Danh sách người dùng đăng kí </h1>
        <div class="row">
            <div class="col mb-4 mt-4">
                <button id="btn-add-user" class="btn btn-success">Thêm Uesr</button>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <table id="user-table" class="table table-striped table-hover table-bordered">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>first name </th>
                            <th>last name</th>
                            <th>country</th>
                            <th>subject</th>
                            <th>customer Type</th>
                            <th>register Status</th>
                            <th>action</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>

    </div>
    <!-- Modal user infor-->
    <div id="user-insert-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">User Detail Information</h5>
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                </div>
                <!-- Modal body - chứa form dữ liệu -->
                <div class="modal-body">
                    <form> <!-- form thiết kế như form bình thường, theo grid model -->


                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">First name</label>
                            <div class="col-sm-8">
                                <input class="form-control" id="input-modal-firstname">
                            </div>
                        </div>

                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Last name</label>
                            <div class="col-sm-8">
                                <input class="form-control" id="input-modal-lastname">
                            </div>
                        </div>

                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Subject </label>
                            <div class="col-sm-8">
                                <input class="form-control" id="input-modal-subject">
                            </div>
                        </div>

                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Country </label>
                            <div class="col-sm-8">
                                <input class="form-control" id="input-modal-country">
                            </div>
                        </div>

                        <div class="row form-group">
                            <label class="col-sm-4 col-form-label">Customer Type</label>
                            <div class="col-sm-8">
                                <input class="form-control" id="input-modal-customer-type">
                            </div>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <div class="row">
                        <button id="btn-modal-insert" class="btn btn-primary">Insert user</button>
                        <button type="button" id="btn-modal-close" class="btn btn-secondary"
                            data-dismiss="modal">Close</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

</body>
<script>
    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_STATUS_DELETE_OK = 204;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_STATUS_CREATE_OK = 201;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        // khai báo nút sửa 
        $("#user-table").on("click", ".btn-edits", onSuaClick); // khai báo nút sửa 
        $("#user-table").on("click", ".btn-deletes", onXoaClick); // khai báo nút xóa
        $("#btn-add-user").on("click", onAddUserClick); // khai báo nút thêm user 
        $("#btn-modal-insert").on("click", onInsertUserClick);
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        "use strict"
        console.log("đã load xong thẻ body ");
        // load data table jquery nhưng chưa truyền dữ liệu 
        khoiTaoDataTable();
        //b1 bỏ qua
        //b2 bỏ qua
        //b3  call api && //b4 load data in table 
        callApiAllUser();
    }
    // khai báo sự kiện nút sửa 
    function onSuaClick() {
        console.log("ấn nút sửa ");
        var vObject = readObjectRow(this);
        console.log("id là:  " + vObject.id);
    }
    // khai báo sự kiện nút xóa user
    function onXoaClick() {
        console.log("ấn nut xóa ");
        var vObject = readObjectRow(this);
        console.log("id là:  " + vObject.id);
    }
    // khai báo sự kiện nút thêm user
    function onAddUserClick() {
        console.log("ấn nut add user ");
        $("#user-insert-modal").modal("show");
    }
    // khai báo nút insert user (add user);
    function onInsertUserClick() {
        console.log("ấn nút insert user ");
        //04 bước xử lý sự kiện có gọi server
        // b1 thu thâpj dữ liệu
        var vObject = readDataModalInsertUser();
        // b2 validate data
        var vResult = validateDataInsertUser(vObject);
        // b3 call server
        if (vResult) {
            $.ajax({
                url: gBASE_URL,
                type: "POST",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vObject),
                // b4 hiển thị font end 
                success: successInsertData,
                error: function (paramError) {
                    console.log(paramError.status);
                }
            });
        }
        // b4
        console.log(vObject);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // ........................ [onPageLoading].......................
    // khởi tạo data table 
    function khoiTaoDataTable() {
        /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
        $("#user-table").DataTable({
            columns: [
                { data: "id" },
                { data: "firstname" },
                { data: "lastname" },
                { data: "country" },
                { data: "subject" },
                { data: "customerType" },
                { data: "registerStatus" },
                { data: "action" }

            ],
            columnDefs: [
                {
                    targets: 0,   // cột id
                    className: "text-center text-primary"
                },
                {
                    targets: 3, // cột age
                    className: "text-right"
                },
                {
                    targets: 7,
                    defaultContent: "<button class='btn btn-primary mr-2 btn-edits'>Sửa</button>" +
                        "<button class='btn btn-danger btn-deletes'>Xóa</button>",
                },
            ]
        });
    }
    //  gọi API load all users
    function callApiAllUser() {
        // khai báo ajax jquery
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            dataType: "json",
            success: function (paramRes) {
                // khi gọi api call all user thành công 
                //b4 load data in table 
                getInsertRowTable(paramRes);
            },
            error: function (paramError) {
                console.log("lỗi khi gọi api All user" + paramError.status);
            }
        });
    }
    // hàm thêm từng dòng dữ liệu vào
    function getInsertRowTable(paramRes) {
        var vTable = $("#user-table").DataTable();
        vTable.clear();// xóa trắng tbody trước khi load dữ liệu 
        vTable.rows.add(paramRes);
        vTable.draw();
    }

    // lấy tất cả giá trị của 1 hàng tương ứng với nút bấm trên hàng đó 
    function readObjectRow(paramThis) {
        console.log(paramThis);
        var vRowClick = $(paramThis).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
        var vTable = $("#user-table").DataTable();   // tạo biến đến dataTable 
        var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
        return vDataRow.data();
    }
    // ........................ [nút insert user in modal].......................
    //04 bước xử lý sự kiện có gọi server
    // b1 thu thâpj dữ liệu và trả về object chứa thông tin người dùng 
    function readDataModalInsertUser() {
        var vObjectDataUser = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
        }
        //gán giá trị cho object 
        vObjectDataUser.firstname = $("#input-modal-firstname").val().trim();
        vObjectDataUser.lastname = $("#input-modal-lastname").val().trim();
        vObjectDataUser.subject = $("#input-modal-subject").val().trim();
        vObjectDataUser.country = $("#input-modal-country").val().trim();
        vObjectDataUser.customerType = $("#input-modal-customer-type").val().trim();
        // kết thúc hàm và trả về đối tượng đã gán 
        return vObjectDataUser;
    }
    // b2 validate data
    // kiểm tra xem người dùng có nhập hay k . nếu không nhập thì nhắc nhở người dùng
    function validateDataInsertUser(paramObject) {
        if (paramObject.firstname === "") {
            alert("first name không được để trống ");
            return false;
        }
        if (paramObject.lastname === "") {
            alert("last name không được để trống ");
            return false;
        }
        if (paramObject.subject === "") {
            alert("subject không được để trống ");
            return false;
        }
        if (paramObject.country === "") {
            alert("country không được để trống ");
            return false;
        }
        if (paramObject.customerType === "") {
            alert("customerType không được để trống ");
            return false;
        }
        return true;
    }


    // b4 hiển thị font end
    function successInsertData(pamramRes) {
        alert("Thêm voucher thành công!");
       // callApiAllUser(); // load dữ liệu mới ra bảng
        resertCreateVoucherForm(); // xóa trắng dữ liệu 
        $("#user-insert-modal").modal("hide");  // ẩn modal
    }

    // hàm xóa trắng form create voucher
    function resertCreateVoucherForm() {
        $("#input-modal-firstname").val("");
        $("#input-modal-lastname").val("");
        $("#input-modal-subject").val("");
        $("#input-modal-country").val("");
        $("#input-modal-customer-type").val("");
    }



</script>

</html>